#ifndef _HEADER_DISPLAY_H_
#define _HEADER_DISPLAY_H_

#include <Arduino.h>
#include <Wire.h>
#include <SPI.h>
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>

#define DISP_CONTRAST 60

#define DISP_MAX_LEN                14
#define DISP_ARRAY_LEN              DISP_MAX_LEN+1
#define DISP_MESSAGE_MAX            5
#define DISP_MESSAGE_TIMEOUT        10

#define IDX_DISP_MSG_SSID           0
#define IDX_DISP_MSG_INT_ERROR      1
#define IDX_DISP_MSG_MQTT_ERROR     2
#define IDX_DISP_MSG_OTH_ERROR2     3

extern Adafruit_PCD8544 display;

struct display_struct
{
    bool timeout;
    bool relay_on;
    int8_t wifi_rssi;
    uint8_t wifi_connected_devices;
    double process_val;
    char message_arr[DISP_MESSAGE_MAX][DISP_MAX_LEN];
    uint8_t message_idx;
};

extern display_struct display_vals;

void display_setup(void);
void display_all(void);
void display_top_line(void);
void display_process_value(void);
void display_message_line(void);
void display_logo(void);
void display_update_params(void);
void display_error(void);


// 'meti-logo1', 39x35px
const unsigned char meti_logo1 [] PROGMEM = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x00, 0x00, 0x00, 0x00, 0x3c, 0x00, 0x00, 0x00, 
	0x00, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x00, 0x00, 0x00, 0x00, 0x7e, 0x00, 0x00, 0x00, 0x00, 
	0xff, 0x00, 0x00, 0x00, 0x01, 0xff, 0x00, 0x00, 0x00, 0x01, 0xff, 0x80, 0x00, 0x00, 0x03, 0xff, 
	0xc0, 0x00, 0x00, 0x03, 0xff, 0xc0, 0x00, 0x00, 0x07, 0xff, 0xe0, 0x00, 0x00, 0x07, 0xff, 0xe0, 
	0x00, 0x00, 0x0f, 0xff, 0xf0, 0x00, 0x00, 0x1f, 0xff, 0xf0, 0x00, 0x00, 0x1f, 0xff, 0xf8, 0x00, 
	0x00, 0x3f, 0xff, 0xf8, 0x00, 0x00, 0x3f, 0xff, 0xfc, 0x00, 0x00, 0x7f, 0xe7, 0xfe, 0x00, 0x00, 
	0x7f, 0x83, 0xfe, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0x01, 0xff, 0xff, 0xff, 0x00, 0x01, 0xf7, 
	0xef, 0xff, 0x80, 0x03, 0xe7, 0xd3, 0xe7, 0x80, 0x03, 0x87, 0x99, 0xe1, 0xc0, 0x07, 0x07, 0x39, 
	0xe0, 0xc0, 0x07, 0x07, 0x39, 0xe0, 0xe0, 0x0f, 0x87, 0xbd, 0xe3, 0xf0, 0x1f, 0xe7, 0xff, 0xe7, 
	0xf0, 0x1f, 0xff, 0xff, 0xff, 0xf8, 0x3f, 0xff, 0xff, 0xff, 0xf8, 0x3f, 0xff, 0x00, 0xff, 0xfc, 
	0x7f, 0xff, 0xc3, 0xff, 0xfc, 0x7f, 0xff, 0xe7, 0xff, 0xfe, 0xff, 0xff, 0xff, 0xff, 0xfe
};

// 'meti-logo2', 53x12px
const unsigned char meti_logo2 [] PROGMEM = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0xff, 0xe3, 0xff, 0x1f, 0xf9, 0xe0, 0x3f, 0xff, 
	0xe3, 0xff, 0x1f, 0xf9, 0xe0, 0x3c, 0x78, 0xe3, 0x80, 0x03, 0x81, 0xe0, 0x3c, 0x78, 0xe3, 0xff, 
	0x03, 0x81, 0xe0, 0x3c, 0x78, 0xe3, 0xff, 0x03, 0x81, 0xe0, 0x3c, 0x78, 0xe3, 0x80, 0x03, 0x81, 
	0xe0, 0x3c, 0x78, 0xe3, 0x80, 0x03, 0x81, 0xe0, 0x3c, 0x78, 0xe3, 0xff, 0x03, 0x81, 0xe0, 0x3c, 
	0x78, 0xe3, 0xff, 0x03, 0x81, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	0x00, 0x00, 0x00, 0x00
};

#endif